/**
 * Implements a linked list with operations insert, delete, and print.
 *
 * @author Michael Dube
 * @version 2.0
 * @since September 27 2019
 */
class List {

    private Node root;

    /**
     * Create an empty linked list
     */
    List() {
        root = null;
    } // constructor

    /**
     * Insert v into this list.
     *
     * @param v value to insert
     */
    int insert(int v) {
        if (root == null) {
            root = new Node(v, null);
        } else {
            root = new Node(v, root);
        }
        return v;
    } // insert

    /**
     * Delete first element in this list.
     *
     * @return value deleted
     */
    int delete() {
        if (root == null) {
            System.out.println("--\n\nERROR: Cannot delete\n\n--");
            return 0;
        } else {
            int value = root.value;
            root = root.next;
            return value;
        }
    } // delete

    /**
     * @return root of list
     */
    Node getRoot() {
        return root;
    } // getRoot

    /**
     * Print this list.
     */
    void print() {
        System.out.print("[");
        if (root == null) {
            System.out.print("empty list");
        } else {
            Node cur = root;
            while (cur != null) {
                System.out.print("  " + cur.value);
                cur = cur.next;
            }
        }
        System.out.println(" ]");
    }  // print

} // List
