/**
 * Implements a Stack using a linked list with operations empty, push, pop, and peek.
 *
 * @author Michael Dube
 * @version 2.0
 * @since September 27 2019
 */
class Stack {

    private List contents;

    /**
     * Creates empty stack.
     */
    Stack() {
        contents = null;
    } // constructor

    /**
     * @return true if stack is empty, null otherwise
     */
    Boolean empty() {
        return contents == null;
    }

    /**
     * Add v to this stack.
     */
    int push(int v) {
        if (empty()) {
            contents = new List();
        }
        return contents.insert(v);
    }

    /**
     * Remove the first item in this stack.
     *
     * @return item removed from stack
     */
    int pop() {
        if (empty()) {
            System.out.println("--\n\nERROR: List is empty\n\n--");
        }
        return contents.delete();
    } // pop

    /**
     * @return first item in this stack
     */
    int peek() {
        if (empty()) {
            System.out.println("--\n\nERROR: List is empty\n\n--");
        }
        return contents.getRoot().value;
    } // peek

    /**
     * Prints out this stack.
     */
    void print() {
        contents.print();
    } // print

} // Stack
